#!/usr/bin/env python
# coding: latin-1
# Autor:   Ingmar Stapel
# Datum:   20160731
# Version:   2.0
# Homepage:   http://custom-build-robots.com
# Mit diesem Programm kann der GPS Empfaenger ausgelesen werden.

import os
from gps import *
import time

# Der Zaehler zeigt dem Anwender wie oft versucht wurde 
# die Koordinaten auszulesen.
count = 0

# Erzeugen der Session fuer den Zugriff auf den Empfaenger.
session = gps(mode=WATCH_ENABLE)

try:
   while True:
      # Warten um die While Schleife etwas zu verzoegern.
      time.sleep(0.5)
      
      # Loeschen des Terminal-Fensters.
      os.system('clear')
      
      # Ausgabe der Statuszeile das das Programm laeuft.
      print 'Auslesen der GPS Koordinaten'
      
      # Der Counter wird hochgesetzt.
      count = count + 1
      
      # Der Anwender wird ueber den Lesezugriff informiert.
      print 'Zaehler:', count ,' Lesezugriffe.'
      session.next()

      # Wenn kein Fix-Punkt vom GPS Empfaenger gefunden 
      # wurde wird der Anwender darueber informiert.
      if session.fix.latitude == 0.0:
         print '-------------------------------------------'
         print 'Es wurden keine GPS Informationen empfangen'
         print 'Wurde der gpsd Daemon schon gestartet?'
         print '-------------------------------------------'
      # werden GPS Koordinaten empfangen so werden diese 
      # ausgegeben.
      else:
         print '------------------ GPS Informationen --------------'
         print 'Breitengrad:  ' , session.fix.latitude
         print 'Laengengrad:  ' , session.fix.longitude
         print 'Zeit utc:     ' , session.utc, \
         session.fix.time
         print '----------------------------------------------------'
# Beenden des Programmes von Hand.         
except StopIteration:
    print "GPSD has terminated"

# Ende des Programmes
