# !/usr/bin/env python
# coding: latin-1
# Autor:   Ingmar Stapel
# Datum:   20160731
# Version:   2.0
# Homepage:   http://custom-build-robots.com

# Mit diesem Programm kann die Adresse des SRF08 Ultraschall 
# Sensors geändert werden.

# Hier wird die smbus Python Bibliothek importiert.
import smbus
import time
import subprocess
import os

# Hier wird das Objekt dev fuer den I2C Bus 1 angelegt.
dev = smbus.SMBus(1)

# es wird der Bildschirm in der Konsole geloescht.
os.system('clear')
 
# Ausgabe einer Statusanzeige was das Programm gerade macht.
print '---------------------------------------------------------'
print 'Suchen nach angeschlossenen i2c Geraeten'
time.sleep(1)
print 'Die folgenden Geraete wurden gefunden:'
print '---------------------------------------------------------'
# Hier wird die Ausgabe des Aufrufes i2cdetect -y 1 via Python
# in dem Terminal-Fenster ausgegeben.
output = subprocess.check_output("i2cdetect -y 1", shell=True)
print output


# Dem Anwender wird angezeigt, dass jetzt die alte und neue Adresse 
# des Sensors eingegeben werden muss.
print '---------------------------------------------------------'
print 'Die Adresse des Sensors kann jetzt gewechselt werden.'
print '---------------------------------------------------------'

try:
   addressOld = raw_input("Aktuelle Adresse eingeben (z. B. 0x70):")
   addressNew = raw_input("Neue Adresse eigeben (0x70 bis 0x77):") 
except ValueError: 
   sys.exit()

print '---------------------------------------------------------'
print 'Pruefen der neuen Adresse auf Zulaessigkeit (0x70 bis 0x77)'

# Die eingegebenen Adressen werden in Integer Werte umgewandelt.
addressOld = int(addressOld, 16)
addressNew = int(addressNew, 16)

# Pruefen ob die neue Adresse zulaessig ist und im vorgegebenen
# Intervall liegt.
# Um die Preufung zu deaktivieren muss hier die IF Abfrage 
# ausgebaut werden.

if addressNew in range(111, 120):

   time.sleep(0.5)
   print 'Die Adresse wird geaendert...'
   print '---------------------------------------------------------'

   # Die neue Adresse wird geändert dazu erfolgt ein Bitshift 
   # nach links der Adresse (z. B. 0x73 << 1 = 0xE6)
   addressNew = addressNew << 1

   # Die Sequenz zum Aendern der Adresse wird an den Sensor 
   # geschickt.
   dev.write_byte_data(addressOld, 0, 0xA0)
   time.sleep(0.065)
   dev.write_byte_data(addressOld, 0, 0xAA)
   time.sleep(0.065)
   dev.write_byte_data(addressOld, 0, 0xA5)
   time.sleep(0.065)
   # setzen der neuen Adresse im Sensor
   dev.write_byte_data(addressOld, 0, addressNew)

   time.sleep(1)
   os.system('clear')

   # Ausgabe einer Statusanzeige was das Programm gerade macht.
   print '---------------------------------------------------------'
   print 'Suchen nach angeschlossenen i2c Geraeten'
   time.sleep(1)
   print 'Die folgenden Geraete wurden gefunden:'
   print '---------------------------------------------------------'
   
   # Hier wird die Ausgabe des Aufrufes i2cdetect -y 1 via Python
   # in dem Terminal-Fenster ausgegeben.
   output = subprocess.check_output("i2cdetect -y 1", shell=True)
   print output
else:
   os.system('clear')
   print '---------------------------------------------------------'
   print"Adresse ungueltig."
   print '---------------------------------------------------------'
# Ende des Programmes
